<?php

namespace SGalinski\TypoScriptReferenceFrontend\Service;

// TODO: Fix this autoloading issue and delete these lines.
require_once getcwd() . '/Packages/Application/SGalinski.TypoScriptReferenceFrontend/Classes/SGalinski/TypoScriptReferenceFrontend/Domain/Model/Attribute.php';
require_once getcwd() . '/Packages/Application/SGalinski.TypoScriptReferenceFrontend/Classes/SGalinski/TypoScriptReferenceFrontend/Service/TsrefRestService.php';
require_once getcwd() . '/Packages/Framework/TYPO3.Flow/Tests/BaseTestCase.php';
require_once getcwd() . '/Packages/Framework/TYPO3.Flow/Tests/UnitTestCase.php';

use SGalinski\TypoScriptReferenceFrontend\Domain\Model\Attribute;
use TYPO3\Flow\Tests\UnitTestCase;

class TsrefRestServiceTest extends UnitTestCase {
	/**
	 * @var TsrefRestService
	 */
	protected $tsrefRestService;

	/**
	 * The constructor is used for dependency injection.
	 *
//	 * @param TsrefRestService $service
	 */
	public function __construct(/*TsrefRestService $service*/) {
		$this->tsrefRestService = new TsrefRestService();
	}

	/**
	 * Creates en Attribute for testing.
	 *
	 * @return Attribute
	 */
	protected function createAttribute() {
		$attribute = new Attribute();
		$attribute->setName('tsrefTestName');
		$attribute->setDescription('This is a test type. Testing addNewAttribute method.');
		$attribute->setIsType(TRUE);
		$attribute->setTypo3Group(Attribute::USER_GROUP);
		$attribute->setMinVersion("2.1");
		return $attribute;
	}

	/**
	 * Tests \SGalinski\TypoScriptReferenceFrontend\Service\TsrefRestService::addNewAttribute
	 *
	 * @test
	 */
	public function addNewAttributeTest() {
		$attribute = $this->createAttribute();
		$response = $this->tsrefRestService->addNewAttribute($attribute);
		echo ' Response: ' . $response;
	}

}